class WordsController < ApplicationController
  before_action :set_word, only: [:show, :edit, :update, :destroy]

  # GET /words
  # GET /words.json
  def index
    #@words = Word.all
    @words = Word.get_page(params[:page])
  end

  # GET /words/1
  # GET /words/1.json
  def show
  end

  # GET /words/new
  def new
    @word = Word.new
  end

  # GET /words/1/edit
  def edit
  end
  
  def test
    if params[:tid].nil?
      @test = Test.new
      @test.user = User.find session[:user]
      @test.save
    else
      @test = Test.find params[:tid]
    end
    @i = JSON.parse(@test.solution).size
   
    @word = Word.find(JSON.parse(@test.questions)[@i])
    @word.word = ''
    
  end
  
  def solve
    @test = Test.find(params[:tid])
    arr = JSON.parse(@test.solution)
    @word = Word.find(params[:sid])
    solution = params[:word][:word]
    if Word.where('word LIKE ? AND description = ?', 
      "%#{solution.strip}%", @word.description).size > 0
      arr << true
      @test.solution = arr.to_json
    else
      arr << false
      @test.solution = arr.to_json
    end
    @test.save if arr.size <= 20
    arr = JSON.parse(@test.solution)
    if arr.size >= 20
      @hits = arr.count(true)
      render template: 'words/results'
      return
    end
    @i = arr.size
   
    @word = Word.find(JSON.parse(@test.questions)[@i])
    @word.word = ''
    render :test
  end

  # POST /words
  # POST /words.json
  def create
    @word = Word.new(word_params)

    respond_to do |format|
      if @word.save
        format.html { redirect_to @word, notice: 'Word was successfully created.' }
        format.json { render :show, status: :created, location: @word }
      else
        format.html { render :new }
        format.json { render json: @word.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /words/1
  # PATCH/PUT /words/1.json
  def update
    respond_to do |format|
      if @word.update(word_params)
        format.html { redirect_to @word, notice: 'Word was successfully updated.' }
        format.json { render :show, status: :ok, location: @word }
      else
        format.html { render :edit }
        format.json { render json: @word.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /words/1
  # DELETE /words/1.json
  def destroy
    @word.destroy
    respond_to do |format|
      format.html { redirect_to words_url, notice: 'Word was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_word
      @word = Word.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def word_params
      params.require(:word).permit(:word, :description, :lang, :pronounce)
    end
end
