require 'test_helper'

class SessionsControllerTest < ActionController::TestCase
  # test "the truth" do
  #   assert true
  # end
  
  setup do
    @u = users(:me)
    @request.env['HTTP_REFERER']='/say/hello'
  end

  teardown do
  end

  test "login" do
    post :create, { username: @u.username, password: 'titok' }
    assert_response :redirect
    assert_not_nil session[:user]
  end
  
  test "logout" do
    get :destroy, nil, { user: @u.id }
    assert_response :redirect
    assert_nil session[:user]
  end
end
