require 'test_helper'

class DoTestTest < ActionDispatch::IntegrationTest
  # test "the truth" do
  #   assert true
  # end
  test "take a test" do
    get url_for(controller: 'say', action: 'hello')
    assert_response :success
    assert_select "div#header", 1
    post_via_redirect '/sessions/create',
      { username: users(:me).username,
        password: 'titok'
      },
      {
        'HTTP_REFERER' => '/say/hello'
      }
    assert_equal session[:user], users(:me).id
    n = Test.count
    get test_path
    assert_response :success
    assert_equal Test.count, n+1
    assert_select "#word_word", 1
    test = assigns[:test]
    word = assigns[:word]
    number_of_answers = JSON.parse(test.solution).size
    post url_for(controller: 'words', action: 'solve', tid: test.id, sid: word.id),
      { word: { word: 'a' } }, 
      { user: users(:me).username }
    assert_equal number_of_answers+1, JSON.parse(assigns[:test].solution).size
  end
end
