require 'test_helper'

class UserTest < ActiveSupport::TestCase
  # def test_the_truth
  test "the truth" do
     assert true
  end
  
  test "cannot save user without username" do
    u = User.new
    assert !u.save, "Houston, we have a problem"
  end
  
  test "cannot save user with existing username" do
    me = users(:me)
    u = User.new username: me.username
    assert !u.save
  end
  
  test "check if encryption is deterministic" do
    assert_equal User.encrypt('titok','a'), users(:me).encrypted_password
  end
end
